window.Gleam.initSearch([{"doc":"lustre_routed","title":"lustre_routed","content":"# lustre_routed\nLustre routed is a helper library for [Lustre](https://lustre.build/)\nthat helps create single-page-applications with the JS history routing\nAPI.  It allows you to create applications with different routes without\nhaving a full-page refresh between the routes.\n\n[![Package Version](https://img.shields.io/hexpm/v/lustre_routed)](https://hex.pm/packages/lustre_routed)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lustre_routed/)\n\n## Quickstart\n```sh\ngleam add lustre_routed\n```\nTake a look at the [basic example](https://gitlab.com/kgroat/lustre_routed/-/tree/main/examples/basic) to get an idea of how to use the library.\n\nFurther documentation can be found at &lt;https://hexdocs.pm/lustre_routed&gt;.\n","url":"index.html"},{"doc":"lustre_routed","title":"Route","content":"pub type Route =\n  List(String)\n When a route is passed to your view and loader functions it will be\n a list of strings.  The path is split by its forward slashes, so that\n &quot;/my/cool/route&quot; gets split to [&quot;my&quot;, &quot;cool&quot;, &quot;route&quot;].\n\nSynonyms:\nlustre_routed.Route\nlustre_routed Route","url":"lustre_routed.html#Route"},{"doc":"lustre_routed","title":"RoutedAction","content":"pub opaque type RoutedAction(orig_action)\n The internal action/message type which is used by the routed application.\n\nSynonyms:\nlustre_routed.RoutedAction\nlustre_routed RoutedAction","url":"lustre_routed.html#RoutedAction"},{"doc":"lustre_routed","title":"RoutedModel","content":"pub opaque type RoutedModel(model)\n The internal state/model which is used by the routed application to\n track its own route state as well as your own state.\n\nSynonyms:\nlustre_routed.RoutedModel\nlustre_routed RoutedModel","url":"lustre_routed.html#RoutedModel"},{"doc":"lustre_routed","title":"back","content":"pub fn back() -&gt; RoutedAction(a)\n Used to pop the latest route off the browser&#39;s history stack\n (equivalent to hitting the back button in the browser).\nSynonyms:\nlustre_routed.back\nlustre_routed back","url":"lustre_routed.html#back"},{"doc":"lustre_routed","title":"forward","content":"pub fn forward() -&gt; RoutedAction(a)\n Used to push the next route back onto the browser&#39;s history stack\n (equivalent to hitting the forward button in the browser).\nSynonyms:\nlustre_routed.forward\nlustre_routed forward","url":"lustre_routed.html#forward"},{"doc":"lustre_routed","title":"go_to","content":"pub fn go_to(route: String) -&gt; RoutedAction(a)\n Used to push a new route into the browser&#39;s history stack.\nSynonyms:\nlustre_routed.go_to\nlustre_routed go_to","url":"lustre_routed.html#go_to"},{"doc":"lustre_routed","title":"listen_for_navigation","content":"pub fn listen_for_navigation() -&gt; Effect(RoutedAction(a))\n Create a lustre effect that listens for changes in the browser&#39;s \n history when the user hits the forward or backward buttons.\nSynonyms:\nlustre_routed.listen_for_navigation\nlustre_routed listen_for_navigation","url":"lustre_routed.html#listen_for_navigation"},{"doc":"lustre_routed","title":"perform","content":"pub fn perform(action: a) -&gt; RoutedAction(a)\n Used to dispatch an action to your own internal state.\nSynonyms:\nlustre_routed.perform\nlustre_routed perform","url":"lustre_routed.html#perform"},{"doc":"lustre_routed","title":"redirect","content":"pub fn redirect(route: String) -&gt; RoutedAction(a)\n Used to replace the current route in the browser&#39;s history.\nSynonyms:\nlustre_routed.redirect\nlustre_routed redirect","url":"lustre_routed.html#redirect"},{"doc":"lustre_routed","title":"routed_application","content":"pub fn routed_application(\n  init: fn(a) -&gt; #(b, Effect(RoutedAction(c))),\n  update: fn(b, c) -&gt; #(b, Effect(RoutedAction(c))),\n  loader: fn(List(String), b) -&gt; Effect(RoutedAction(c)),\n  view: fn(List(String), b) -&gt; Element(RoutedAction(c)),\n) -&gt; App(a, RoutedModel(b), RoutedAction(c))\n Creates a lustre application which uses history-based routing.\nSynonyms:\nlustre_routed.routed_application\nlustre_routed routed_application","url":"lustre_routed.html#routed_application"},{"doc":"lustre_routed","title":"lustre_routed","content":" Lustre routed is a helper library for [Lustre](https://lustre.build/)\n that helps create single-page-applications with the JS history routing\n API.  It allows you to create applications with different routes without\n having a full-page refresh between the routes.","url":"lustre_routed.html"},{"doc":"lustre_routed/link","title":"link","content":"pub fn link(\n  href: String,\n  attributes: List(Attribute(RoutedAction(a))),\n  content: List(Element(RoutedAction(a))),\n) -&gt; Element(RoutedAction(a))\n Creates an `&lt;a&gt;` element which hooks into the history api.  Clicking\n on the element will not cause a full page refresh but instead will push\n a new element onto the history stack.\nSynonyms:\nlustre_routed/link.link\nlustre_routed/link link","url":"lustre_routed/link.html#link"},{"doc":"lustre_routed/link","title":"lustre_routed/link","content":"","url":"lustre_routed/link.html"}]);